from hamcrest import assert_that, equal_to
from pytest import fixture

from credit_calculator import result

# Вариант №2 для Задачи №3 (автотесты) - покрыть все случаи end-to-end тестами


@fixture(
    params=[
        # Не совершеннолетний - не выдается
        (
            1,
            20,
            15,
            "наёмный работник",
            2,
            "M",
            17,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Не совершеннолетний - не выдается
        (
            1,
            20,
            15,
            "наёмный работник",
            2,
            "M",
            8,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Пенсионный возраст превышает, мужчина - не выдается
        (
            1,
            20,
            15,
            "наёмный работник",
            2,
            "M",
            46,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Пенсионный возраст превышает, женщина - не выдается
        (
            1,
            10,
            15,
            "наёмный работник",
            2,
            "F",
            51,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Запрашиваемая сумма деленная на срок превышает доход / 3
        (
            5,
            1,
            12,
            "наёмный работник",
            2,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Запрашиваемая сумма деленная на срок превышает доход / 3
        (
            5,
            1,
            14.99,
            "наёмный работник",
            2,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Запрашиваемая сумма деленная на срок равна доход / 3
        (
            5,
            1,
            15,
            "наёмный работник",
            2,
            "F",
            38,
            "ипотека",
            """1. КРЕДИТ ВЫДАЕТСЯ.
2. ГОДОВОЙ ПЛАТЕЖ ПО КРЕДИТУ: ~5.315 млн.""",
        ),
        # Кредитный рейтинг -2
        (
            5,
            1,
            45,
            "наёмный работник",
            -2,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Безработный
        (
            5,
            1,
            35,
            "безработный",
            1,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Превышение максимальной суммы по виду деятельности пассивный доход
        (
            1.1,
            1,
            25,
            "пассивный доход",
            2,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Превышение максимальной суммы по виду деятельности пассивный доход
        (
            10,
            1,
            25,
            "пассивный доход",
            2,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Граничное максимальной суммы по виду деятельности пассивный доход
        (
            0.99,
            1,
            25,
            "пассивный доход",
            2,
            "F",
            38,
            "ипотека",
            """1. КРЕДИТ ВЫДАЕТСЯ.
2. ГОДОВОЙ ПЛАТЕЖ ПО КРЕДИТУ: ~1.067 млн.""",
        ),
        # Превышение максимальной суммы по виду деятельности наемный работник
        (
            5.1,
            1,
            45,
            "наёмный работник",
            1,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Превышение максимальной суммы по виду деятельности наемный работник
        (
            9,
            1,
            45,
            "наёмный работник",
            1,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Граничное максимальной суммы по виду деятельности наемный работник
        (
            4.99,
            1,
            45,
            "наёмный работник",
            1,
            "F",
            38,
            "ипотека",
            """1. КРЕДИТ ВЫДАЕТСЯ.
2. ГОДОВОЙ ПЛАТЕЖ ПО КРЕДИТУ: ~5.329 млн.""",
        ),
        # Превышение максимальной суммы по виду деятельности наемный работник
        (
            9,
            1,
            45,
            "наёмный работник",
            1,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Превышение максимальной суммы по кредитному рейтингу -1
        (
            9,
            1,
            45,
            "собственный бизнес",
            -1,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Превышение максимальной суммы по кредитному рейтингу -1
        (
            1.1,
            1,
            45,
            "собственный бизнес",
            -1,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Граничное максимальной суммы по кредитному рейтингу -1
        (
            1,
            1,
            45,
            "собственный бизнес",
            -1,
            "F",
            38,
            "ипотека",
            """1. КРЕДИТ ВЫДАЕТСЯ.
2. ГОДОВОЙ ПЛАТЕЖ ПО КРЕДИТУ: ~1.097 млн.""",
        ),
        # Превышение максимальной суммы по кредитному рейтингу 0
        (
            5.1,
            1,
            45,
            "собственный бизнес",
            0,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Превышение максимальной суммы по кредитному рейтингу 0
        (
            8,
            1,
            45,
            "собственный бизнес",
            0,
            "F",
            38,
            "ипотека",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Граничное максимальной суммы по кредитному рейтингу 0
        (
            5,
            1,
            45,
            "собственный бизнес",
            0,
            "F",
            38,
            "ипотека",
            """1. КРЕДИТ ВЫДАЕТСЯ.
2. ГОДОВОЙ ПЛАТЕЖ ПО КРЕДИТУ: ~5.378 млн.""",
        ),
        # Модификатор базовой ставки = -0,25 -1 + 0,25
        (
            10,
            20,
            15,
            "собственный бизнес",
            1,
            "M",
            25,
            "автокредит",
            """1. КРЕДИТ ВЫДАЕТСЯ.
2. ГОДОВОЙ ПЛАТЕЖ ПО КРЕДИТУ: ~1.400 млн.""",
        ),
        # Модификатор базовой ставки = -2 + 1,5 - 1 + 0,5
        (
            0.1,
            1,
            15,
            "пассивный доход",
            -1,
            "M",
            64,
            "ипотека",
            """1. КРЕДИТ ВЫДАЕТСЯ.
2. ГОДОВОЙ ПЛАТЕЖ ПО КРЕДИТУ: ~0.111 млн.""",
        ),
        # Модификатор базовой ставки = -0,5 + 0 + 0 - 0,25
        (
            1,
            1,
            15,
            "наёмный работник",
            0,
            "F",
            59,
            "развитие бизнеса",
            """1. КРЕДИТ ВЫДАЕТСЯ.
2. ГОДОВОЙ ПЛАТЕЖ ПО КРЕДИТУ: ~1.093 млн.""",
        ),
        # Модификатор базовой ставки = 1,5 -0,75 + 0 - 0,25
        (
            1,
            1,
            15,
            "наёмный работник",
            2,
            "F",
            25,
            "потребетельский",
            """1. КРЕДИТ ВЫДАЕТСЯ.
2. ГОДОВОЙ ПЛАТЕЖ ПО КРЕДИТУ: ~1.090 млн.""",
        ),
        # Годовой платеж превышает половину дохода
        (
            1,
            1,
            2,
            "наёмный работник",
            2,
            "M",
            25,
            "потребетельский",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
        # Годовой платеж превышает половину дохода
        (
            1,
            1,
            0.1,
            "наёмный работник",
            2,
            "M",
            25,
            "потребетельский",
            "КРЕДИТ НЕ ВЫДАЕТСЯ.",
        ),
    ]
)
def result_params(request):
    return request.param


def test_e2e(result_params):
    (
        request,
        maturity,
        revenue,
        source,
        rating,
        sex,
        age,
        purpose,
        expected_result,
    ) = result_params
    assert_that(
        result(request, maturity, revenue, source, rating, sex, age, purpose),
        equal_to(expected_result),
    )
